<?php
$isMaster = $this->environment()->getClient()->isMaster();
$bubble   = $this->module()->getClientModuleConfiguration('indicator', 'analysis_bubble');
$line     = $this->module()->getClientModuleConfiguration('indicator', 'analysis_line');
$bar      = $this->module()->getClientModuleConfiguration('indicator', 'analysis_bar');
$pie      = $this->module()->getClientModuleConfiguration('indicator', 'analysis_pie');
?>

<div ng-controller="recapController as self"
     ng-init="self.initQueries()">
    <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
        <div class="row">
            <div class="col-md-4 col-md-offset-8">
                <div class="queries-toggler little-panel">
                    <div href="#queries-collapsed-node-tree-recap"
                         data-toggle="collapse"
                         class="title">
                        <i class="fa fa-shopping-basket fa-fw"></i>
                        Requêtes
                    </div>

                    <div id="queries-collapsed-node-tree-recap"
                         class="body collapse">
                        <div ng-if="self.loadingQueries"
                             class="text-center">
                            <i class="fa fa-spin fa-circle-o-notch"></i>
                        </div>

                        <ul class="list-unstyled">
                            <li ng-repeat="query in self.queries">
                                <a ng-click="self.loadQuery(query)"
                                   class="pointer">
                                    <i ng-if="query.shared" class="fa fa-share-alt"></i> {{ query.name }}
                                </a>

                                <i ng-click="self.deleteQuery(query)" ng-if="query._rights.delete"
                                   tooltip="Supprimer"
                                   class="fa fa-trash pointer pull-right">
                                </i>
                            </li>
                        </ul>

                        <form ng-submit="self.saveQuery()"
                              name="queryForm">
                            <div class="input-group input-group-sm">
                                <input ng-model="self.query.name"
                                       placeholder="Nom de la requête"
                                       type="text"
                                       class="form-control"
                                       required/>

                                <span class="input-group-btn">
                                    <?php if (!$this->acl()->onlyOwned('application:e:query:r') && !$this->acl()->onlyOwned('application:e:query:u')) : ?>
                                        <label class="checkbox-inline" style="margin: 0 10px">
                                            <input type="checkbox" ng-model="self.query.shared"/>
                                            Partagée ?
                                        </label>
                                    <?php endif; ?>

                                    <button ng-disabled="self.loadingSaveQuery"
                                            type="submit"
                                            class="btn btn-submit">
                                        <i ng-if="self.loadingSaveQuery"
                                           class="fa fa-spin fa-circle-o-notch">
                                        </i>
                                        Enregistrer
                                    </button>
                                </span>
                            </div>

                            <field-errors field="name"
                                          errors="errors.fields">
                            </field-errors>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    <?php endif ?>
    <div class="row separator">
        <div ng-controller="filterController as filter"
             ng-init="filter.init('indicator')"
             class="col-md-4">
            <div class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-indicator">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('indicator_entity')) ?>
                </div>
                <div id="filters-collapsed-recap-indicator" class="body collapse">
                    <?= $this->tableFilter('self.filters.indicator', $this->indicatorFilters()); ?>
                </div>
            </div>
        </div>
        <?php if ($this->module()->isActive('project') && !$isMaster): ?>
            <div ng-controller="projectFilterController as filter"
                 ng-init="filter.init('project', null, <?= $isMaster ? 'false' : 'true' ?>)"
                 class="col-md-4">
                <div class="table-filters little-panel">
                    <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-project">
                        <?= $this->icon('filters', 'fa-fw') ?>
                        <?= $this->translate('filters') ?>
                        <?= ucfirst($this->translate('project_entity')) ?>
                    </div>
                    <div id="filters-collapsed-recap-project" class="body collapse project">
                        <?= $this->tableFilter('self.filters.project', $this->projectFilters($isMaster ? ['external', 'ownership', 'networkAccessible', 'managers', 'validators', 'members', 'actors', 'ownership', 'parent', 'financer', 'level', 'budgetStatus'] : [])); ?>
                    </div>
                </div>
            </div>
        <?php endif ?>
        <div ng-controller="measureController as filter"
             ng-init="filter.init('measure')"
             class="col-md-4">
            <div class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-measure">
                    <?= $this->icon('filters', 'fa-fw') ?>
                    <?= $this->translate('filters') ?>
                    <?= ucfirst($this->translate('measure_entity')) ?>
                </div>
                <div id="filters-collapsed-recap-measure" class="body collapse">
                    <?= $this->tableFilter('self.filters.measure', $this->measureFilters($isMaster ? ['indicator', 'project'] : ['indicator', 'project', 'client'])); ?>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator">
        <div class="col-md-4">
            <div ng-controller="filterController"
                 class="table-filters little-panel">
                <div class="title" data-toggle="collapse" href="#filters-collapsed-recap-group">
                    <?= ucfirst($this->translate('group_by')) ?>
                </div>
                <div id="filters-collapsed-recap-group" class="body collapse project">
                    <select class="form-control" ng-model="self.filters.group">
                        <option value="indicator">
                            <?= ucfirst($this->translate('indicator_entity')) ?>
                        </option>
                        <?php if ($this->module()->isActive('keyword')): ?>
                            <option value="keyword">
                                <?= ucfirst($this->translate('keyword_entity')) ?>
                            </option>
                        <?php endif ?>
                        <?php if ($this->module()->isActive('map')): ?>
                            <option value="territory">
                                <?= ucfirst($this->translate('territory_entity')) ?>
                            </option>
                        <?php endif ?>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator">
        <div class="col-md-4 col-md-offset-4">
            <div class="row">
                <div class="col-xs-6">
                    <button class="btn" ng-click="self.resetFilters();">
                        <?= $this->translate('table_filter_reset_button') ?>
                    </button>
                </div>
                <div class="col-xs-6 text-right">
                    <button class="btn" ng-click="self.applyFilters();">
                        <?= $this->icon('search', 'fa-fw') ?>
                        <?= $this->translate('table_filter_button') ?>
                    </button>
                </div>
            </div>
        </div>
    </div>
    <div class="row separator" ng-if="self.loading">
        <div class="col-xs-12 text-center">
            <?= $this->icon('loading') ?>
        </div>
    </div>
    <div class="row">
        <div class="col-sm-12">
            <div class="btn-group pull-right">
                <button class="btn btn-excel"
                        type="button"
                        ng-click="self.export()"
                        tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                    <?= $this->icon('excel', 'fa-fw pointer') ?>
                </button>
            </div>
            <?php if ($bubble) : ?>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'bubble'">
                        <i class="fa fa-circle-o"></i>
                    </button>
                </div>
            <?php endif; ?>
            <?php if ($line) : ?>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'line'">
                        <i class="fa fa-line-chart"></i>
                    </button>
                </div>
            <?php endif; ?>
            <?php if ($bar) : ?>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'bar'">
                        <i class="fa fa-bar-chart"></i>
                    </button>
                </div>
            <?php endif; ?>
            <?php if ($pie) : ?>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'pie'">
                        <i class="fa fa-pie-chart"></i>
                    </button>
                </div>
            <?php endif; ?>
            <?php if ($bubble || $line || $bar || $pie) : ?>
                <div class="btn-group pull-right">
                    <button type="button" class="btn" ng-click="self.view = 'table'">
                        <i class="fa fa-table"></i>
                    </button>
                </div>
            <?php endif; ?>
            <br />
            <br />
        </div>
    </div>
    <div class="row">
        <div class="col-sm-12">
            <div class="pull-left">
                <?= $this->translate('number_filters') ?>
            </div>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'line'">
        <div class="col-xs-12">
            <nvd3 options="self.chart.line.options" data="self.chart.line.data" api="self.chart.line.api"></nvd3>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'bubble'">
        <div class="col-xs-12">
            <nvd3 options="self.chart.bubble.options" data="self.chart.bubble.data" api="self.chart.bubble.api"></nvd3>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'bar'">
        <div class="col-xs-12">
            <nvd3 options="self.chart.bar.options" data="self.chart.bar.data" api="self.chart.bar.api"></nvd3>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'pie'">
        <div class="col-xs-12" ng-repeat="pie in self.chart.pie">
            <h3>{{pie.name}}</h3>
            <nvd3 options="pie.options" data="pie.data" api="pie.api"></nvd3>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'table'">
        <div class="col-xs-12">
            <div class="table-scroller">
                <table class="table table-bordered table-condensed table-hover">
                    <thead>
                    <tr>
                        <th colspan="{{self.group == 'keyword' ? 3 : (self.group == 'territory' ? 2 : 1)}}">
                            <button class="btn btn-default btn-xs pull-left" ng-click="self.details = !self.details">
                                Afficher / Masquer les détails
                            </button>
                        </th>
                        <th colspan="{{self.details ? 3 : 1}}" ng-repeat="year in self.years">
                            {{year}}
                        </th>
                    </tr>
                    <tr>
                        <th ng-if="self.group == 'keyword'">
                            <?= ucfirst($this->translate('group_entity')) ?>
                        </th>
                        <th ng-if="self.group == 'keyword'">
                            <?= ucfirst($this->translate('keyword_entity')) ?>
                        </th>
                        <th ng-if="self.group == 'territory'">
                            <?= ucfirst($this->translate('territory_entity')) ?>
                        </th>
                        <th>
                            <?= ucfirst($this->translate('indicator_entity')) ?>
                        </th>

                        <th ng-repeat-start="year in self.years" ng-show="self.details">
                            <?= ucfirst($this->translate('measure_type_target')) ?>
                        </th>
                        <th ng-show="self.details">
                            <?= ucfirst($this->translate('measure_type_done')) ?>
                        </th>
                        <th ng-repeat-end>
                            %
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr ng-repeat="indicator in self.indicators">
                        <td ng-if="self.group == 'keyword'">
                            {{indicator.group}}
                        </td>
                        <td ng-if="self.group == 'keyword'">
                            {{indicator.keyword}}
                        </td>
                        <td ng-if="self.group == 'territory'">
                            {{indicator.territory}}
                        </td>
                        <td>
                            {{indicator.name}} <i>{{indicator.uom ? '(' + indicator.uom + ')' : ''}}</i>
                        </td>

                        <td ng-repeat-start="year in self.years" class="text-right" ng-show="self.details">
                            <span ng-if="indicator.type == '<?= \Indicator\Entity\Indicator::TYPE_FREE ?>'">
                                {{indicator.data.intermediate[year].target.value}}
                            </span>
                            <span ng-if="indicator.type == '<?= \Indicator\Entity\Indicator::TYPE_FIXED ?>' && indicator.data.intermediate[year].target.value !== null">
                                <span ng-style="{ backgroundColor: indicator.data.intermediate[year].target.content.color}" class="indicator-fixed-badge"></span>
                                {{indicator.data.intermediate[year].target.content.text}}
                            </span>
                        </td>
                        <td class="text-right" ng-show="self.details">
                            <span ng-if="indicator.type == '<?= \Indicator\Entity\Indicator::TYPE_FREE ?>'">
                                {{indicator.data.intermediate[year].done.value}}
                            </span>
                            <span ng-if="indicator.type == '<?= \Indicator\Entity\Indicator::TYPE_FIXED ?>' && indicator.data.intermediate[year].done.value !== null">
                                <span ng-style="{ backgroundColor: indicator.data.intermediate[year].done.content.color }" class="indicator-fixed-badge"></span>
                                {{indicator.data.intermediate[year].done.content.text}}
                            </span>
                        </td>
                        <td ng-repeat-end class="text-right" ng-class="{
                                    'indicator-ratio-100': indicator.data.intermediate[year].ratio >= 100,
                                    'indicator-ratio-50': indicator.data.intermediate[year].ratio > 0 && indicator.data.intermediate[year].ratio < 100,
                                    'indicator-ratio-0': indicator.data.intermediate[year].ratio <= 0 && indicator.data.intermediate[year].ratio !== null && indicator.data.intermediate[year].ratio !== ''
                                }">
                            {{indicator.data.intermediate[year].ratio || indicator.data.intermediate[year].ratio === 0 ? indicator.data.intermediate[year].ratio + ' %' : ''}}
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
